﻿using Microsoft.SharePoint.Client.Services;
using System.ServiceModel.Activation;
using Microsoft.SharePoint;
using System.Collections.Generic;
using Microsoft.SharePoint.Utilities;

namespace SPGSvcWp
{
    [BasicHttpBindingServiceMetadataExchangeEndpoint]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Required)]
    public class SPGRestItemService : ISPGRestItemService
    {
        // To test this service, use the Visual Studio WCF Test client
        // set the endpoint to http://<Your server name>/_vti_bin/SPGSvcWp/SPGRestItemService.svc/GetItem
        public PropertyInfo[] GetItem(string id)
        {
            SPContext ctx = SPContext.Current;
            SPList list = ctx.Web.GetList("/SitePages");
            int listId = 0;
            if (!int.TryParse(id, out listId))
            {
                return null;
            }
            SPListItem item = list.GetItemById(listId);

            if (item == null)
            {
                return null;
            }

            var properties = new List<PropertyInfo>();

            foreach (SPField f in item.Fields)
            {
                try
                {
                    properties.Add(new PropertyInfo
                    {
                        N = f.Title,
                        I = f.InternalName,
                        V = item.GetFormattedValue(f.InternalName),
                    });
                }
                catch
                {

                }
            }

            return properties.ToArray();
        }
    }
}
